
EclaireXL - Bug #67

Pokey two tone timing problem

06/01/2018 10:42 AM - admin

Status: Resolved Start date: 06/01/2018

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0:00 hour

Target version:    

Description

An old bug.. See http://atariage.com/forums/topic/228527-pokey-emulation/page-3#entry3060595

10 P=53760

20 POKE P+8,64

30 POKE P+1,10+32

31 POKE 53775,11

40 POKE P,20

50 GOTO 50

high pitched, low pitched on real Atari

History

#1 - 06/14/2018 08:35 PM - foft

Related post: http://atariage.com/forums/topic/118448-implementation-of-pokey-2-tone-filter-in-emulation/page-3#entry1449990

#2 - 06/19/2018 09:54 PM - foft

Been measuring cases on the scope...

Confirmed the extra cycle delays described in that forum post on my 600XL. Confirmed missing on the EclaireXL implementation.

#3 - 06/19/2018 09:55 PM - foft

I was concerned that my clocks were off at first since I was running in VGA mode, but that changes vsync slightly (50Hz vs 4.86Hz) which of course

also impacts audio frequency:-) Debugging in RGB mode gives a perfect match.

#4 - 06/20/2018 09:27 PM - foft

A 2 cycle delay on the reset fixes both the 4 cycle and the 9 cycle case.

Now to check this specific example!

#5 - 06/20/2018 09:57 PM - foft

Nope, seems to be some interaction with the noise filtering. I wonder if the delay also needs applying to the pulse from the timer, that then hits the

noise filter.

#6 - 06/20/2018 10:03 PM - foft

- File Screenshot from 2018-06-20 23-02-19.png added

So, errr identical then! Going to have to think about this one...

B is Atari, A is EclaireXL.
#7 - 06/21/2018 09:44 PM - foft

I found if I pokey 53775,11+128 on the Atari then it matches the Eclaire output. Unfortunately forcing the serious output on eclaire to 1 or 0 does not

change anything. Still its something to go on!

#8 - 01/14/2021 10:38 AM - foft

I have audio test pcbs now to allow synchronised writes to pokeymax vs pokey. Which should help track down this kind of thing.

#9 - 09/23/2021 08:44 PM - foft

This was fixed following investigation and a simple test case/detailed spreadsheet from Synthpopalooza.

I used these new audio test pcbs and a cycle exact fpga comparison program to check it against the real pokey.

Incidentally I found another few small intermittent cycle differences which I'll be able to track down with this too.

#10 - 09/23/2021 08:44 PM - foft

- Status changed from New to Resolved
